package demux.matroska;

import java.io.IOException;
import java.io.RandomAccessFile;
import java.math.BigDecimal;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;

import common.Util;
import common.matroska.MatroskaConstants;
import common.matroska.MatroskaDecoder;

public class ChapterExtractor {
	public static void main(String args[]) {
		try {
			//FileStream stream=new FileStream(null, new File[]{new File("D:/images/Milk.mkv","r")});
			FileChannel channel=new RandomAccessFile("D:/Video/The Army Of Darkness.mkv","r").getChannel();
			new ChapterExtractor().extract(channel);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	public void extract(FileChannel channel) throws IOException {
		MatroskaDecoder.IdInfo idInfo=MatroskaDecoder.getNextChunkInfo(channel);
		if (idInfo.id != MatroskaConstants.EBML) {
			throw new RuntimeException("Not Matroska!");
		}
		idInfo=MatroskaDecoder.scanForId(channel, MatroskaConstants.Segment, channel.size(), true);
		long segmentStart=channel.position() + idInfo.idLen;
		channel.position(segmentStart);
		long segmentEnd=channel.position() + idInfo.len;
		
		/*idInfo=MatroskaDecoder.scanForId(channel, MatroskaConstants.TimecodeScale, segmentEnd, true);
		channel.position(channel.position() + idInfo.idLen);
		long timecodeScale=MatroskaDecoder.getULong((int)idInfo.len, channel);*/
		long timecodeScale=1000000;
		
		idInfo=MatroskaDecoder.scanForId(channel, MatroskaConstants.EditionEntry, segmentEnd, true);
		channel.position(channel.position() + idInfo.idLen);
		long editionEnd=channel.position() + idInfo.len;
		idInfo=MatroskaDecoder.scanForId(channel, MatroskaConstants.ChapterAtom, editionEnd, false);
		int chapterCounter=1;
		System.out.println("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
		System.out.println("<root>");
		while (idInfo!=null) {
			channel.position(channel.position() + idInfo.idLen);
			long chapEnd=channel.position()+idInfo.len;
			long startTime=-1;
			String chapterName="Chapter " + chapterCounter++;
			while (channel.position() < chapEnd) {
				idInfo=MatroskaDecoder.getNextChunkInfo(channel);
				channel.position(channel.position() + idInfo.idLen);
				if (idInfo.id==MatroskaConstants.ChapterTimeStart) {
					startTime=MatroskaDecoder.getULong((int)idInfo.len, channel);
				} else if (idInfo.id==MatroskaConstants.ChapterDisplay) {
					long chapDispEnd=channel.position() + idInfo.len;
					idInfo=MatroskaDecoder.scanForId(channel, MatroskaConstants.ChapString, chapDispEnd, false);
					if (idInfo != null) {
						channel.position(channel.position() + idInfo.idLen);
						byte[] stringBytes=new byte[(int)idInfo.len];
						ByteBuffer stringBtyeBuffer=ByteBuffer.wrap(stringBytes);
						channel.read(stringBtyeBuffer);
						chapterName=new String(stringBytes, 0, stringBytes.length,"UTF-8");
					}
					channel.position(chapDispEnd);
				} else {
					channel.position(channel.position() + idInfo.len);
				}
				
			}
			BigDecimal bd=new BigDecimal(startTime).divide(new BigDecimal(timecodeScale * 1000),6,BigDecimal.ROUND_HALF_UP);
			//System.out.println(startTime);
			System.out.println("<commercial start=\"" + bd + "\" end=\"" +bd + "\" />");
			//System.out.println(chapterName+'=' + Util.timeToString(startTime/timecodeScale));
			idInfo=MatroskaDecoder.scanForId(channel, MatroskaConstants.ChapterAtom, editionEnd, false);
		}
		System.out.println("</root>");
	}

}
