package muxer.filter;

import java.io.IOException;

import muxer.MuxFilter;
import muxer.MuxManager;

import common.mpeg.MpegUtil;
import common.packet.Packet;

import demux.ts.TsRawPacketPart;

/**
 * Only deals with TsRawPackets
 *
 */
public class CoreMuxFilter extends MuxFilter {
	private int streamId;
	private int subStreamId;
	private boolean subStream=false;
	
	public CoreMuxFilter(int streamId, int subStreamId) {
		this.streamId=streamId;
		this.subStreamId=subStreamId;
	}
	
	public int addPacket(Packet packet) throws IOException {
		if (packet.getStreamId()==streamId) {
			TsRawPacketPart packetPart=(TsRawPacketPart)packet.getPayload();
			if (packetPart.getTsInfo().pidStart) {
				subStream=MpegUtil.getPesSubStream(packetPart, packetPart.getPesHeaderOffset())==subStreamId;
			}
			if (subStream) {
				return super.addPacket(packet);
			} else {
				return MuxManager.CONTINUE;
			}
		} else {
			return super.addPacket(packet);
		}
	}
	
	public int getPosition() {
		return POSITION_PRE_BUFFER;
	}
}
