package regulator;

import java.util.HashMap;

import muxer.MuxManager;
import muxer.PacketBuffer;
import muxer.PacketBufferRegulatorI;

import common.packet.Packet;

public class AllStreamPacketBufferRegulator implements PacketBufferRegulatorI {
	private int streamCount=0;
	private HashMap countMap=new HashMap();
	
	public AllStreamPacketBufferRegulator(int streamCount) {
		this.streamCount=streamCount;
	}
	public void addedPacket(PacketBuffer packetBuffer, Packet lastPacket) {
		Integer streamId=Integer.valueOf(lastPacket.getStreamId());
		int count[]=(int[])countMap.get(streamId);
		if (count==null) {
			count=new int[1];
		}
		count[0]++;
	}
	public int isFull() {
		return countMap.size()==streamCount ? MuxManager.CONTINUE : MuxManager.DO_NOTHING;
	}
	public void removedPacket(Packet packet) {
		Integer streamId=Integer.valueOf(packet.getStreamId());
		int count[]=(int[])countMap.get(streamId);
		if (count[0]==1) {
			countMap.remove(streamId);
		}
	}
}
