package util;

import java.io.File;
import java.io.IOException;

import muxer.MuxFilter;
import muxer.MuxManager;

import common.FileStream;
import common.Job;
import common.Util;
import common.mpeg.MpegUtil;
import common.packet.ClockReferenceI;
import common.packet.Packet;

import demux.ts.M2tsRawDemuxer;
import demux.ts.TsRawDemuxer;
import demux.ts.TsRawPacketPart;

public class TsAnalyzer extends MuxFilter {
	private int pmtId;
	private int pcrId;
	private long lastScr;
	
	private long bytes=0;
	public static void main(String args[]) {
		try {
			//String fileName="F:/homeVideo/5-Dad-Opening Presents.MTS";
			//String fileName="F:/xmen3.mts";
			//String fileName="J:/BDMV/STREAM/00008.m2ts";
			//String fileName="F:/Black Hawk Down.m2ts";
			//String fileName="C:/CSI_ Crime Scene Investigation - Monster in the Box.ts";
			//String fileName="F:/T2.ts";
			//String fileName="C:/King Kong.ts";
			//String fileName="C:/Walk the Line.ts";
			//String fileName="C:/Walk the Line VDR.ts";
			//String fileName="C:/Walk the Line TSR.ts";
			//String fileName="I:/BDMV/STREAM/00028.m2ts";
			//String fileName="F:/homeVideo/2007-11 Christmas Mom's.ts";
			//String fileName="H:/Ratatouille.ts";
			//String fileName="H:/Walk Hard.ts";
			//String fileName="I:/BDMV/STREAM/00000.m2ts";
			//String fileName="L:/Video/Aeon Flux.ts_new.ts";
			String fileName="D:/Video/Friends_WUHF_2010_05_28_12_29_00.ts";
			//String fileName="C:/Temp/Aeon Flux.ts";
			//String fileName="G:/BDMV/STREAM/00008.m2ts";
			//String fileName="M:/Batman Begins.ts";
			//String fileName="H:/Video/Terminator_ The Sarah Connor Chronicles-(Pilot)-2008-01-13-0.ts";
			if (args.length==1) {
				fileName=args[0];
			}
			FileStream fileJob=new FileStream(new Job(null), new File[]{new File(fileName)});
			TsRawDemuxer demuxer=(fileName.toLowerCase().endsWith(".ts"))?new TsRawDemuxer():new M2tsRawDemuxer();
			//TsRawDemuxer demuxer=new M2tsRawDemuxer();
			//TsRawDemuxer demuxer=new TsRawDemuxer();
			
			MuxManager muxManager=new MuxManager(demuxer);
			muxManager.add(new TsAnalyzer());
			muxManager.mux(fileJob);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public int addPacket(Packet packet) throws IOException {
		TsRawPacketPart packetPart=(TsRawPacketPart)packet.getPayload();
		
		int streamId=packet.getStreamId();
		if (streamId==0) {
			pmtId=packetPart.getPmtPid(packetPart.getTsSyncOffset())[0][1];
			System.out.println("PMT StreamId: " + pmtId);
		} else if (streamId==pmtId) {
			System.out.println(Integer.toHexString(streamId) + ": PMT");
			//TODO: Parse PMT;
		} else if (packetPart.isSystemClockReference()) {
			long scr=packetPart.getClockReference(ClockReferenceI.CLOCK_REFERENCE_TYPE_SYSTEM);
			if (lastScr > scr) {
				System.out.println("************ Last SCR greater than SCR");
			}
			System.out.println(Integer.toHexString(streamId) + ": SCR: " + MpegUtil.pesTimeToString(scr));
			lastScr=scr;
		} else if (packetPart.isAvStream() && packetPart.getTsInfo().pidStart) {
			StringBuffer sb=new StringBuffer(Integer.toHexString(streamId));
			long pts=packetPart.getClockReference(ClockReferenceI.CLOCK_REFERENCE_TYPE_PTS);
			sb.append(": ");
			
			/*//packetPart.get16(packetPart.getPesHeaderOffset()+4);
			Util.appendHex(packetPart.get(packetPart.getPesHeaderOffset()+4), sb);
			Util.appendHex(packetPart.get(packetPart.getPesHeaderOffset()+5), sb);*/
			if (pts >=0) {
				//sb.append(" - ");
				sb.append(MpegUtil.pesTimeToString(pts));
				long dts=packetPart.getClockReference(ClockReferenceI.CLOCK_REFERENCE_TYPE_DTS);
				if (dts >=0) {
					sb.append(" - ");
					sb.append(MpegUtil.pesTimeToString(dts));
				} else {
					sb.append("              ");
				}
				int subStreamId=MpegUtil.getPesSubStream(packetPart, packetPart.getPesHeaderOffset());
				if (subStreamId > 0) {
					sb.append(" SubStream: " + Integer.toString(subStreamId, 16));
				}
			}
			sb.append(" - ");
			//sb.append(Long.toHexString(bytes));
			int headerOffset=packetPart.getPesHeaderOffset();
			for (int i=0;i<28 && (i+headerOffset)<packetPart.limit();i++) {
				Util.appendHex(packetPart.get(headerOffset + i), sb);
				sb.append(' ');
			}
			System.out.println(sb) ;
			if (pts > 0 && pts < lastScr) {
				System.out.println("************");
			}
		}
		bytes +=packetPart.limit();
		return MuxManager.CONTINUE;
	}
	public int getPosition() {
		return POSITION_MUXER;
	}
}
